import { world, MinecraftEffectTypes, system, Location, MolangVariableMap } from "@minecraft/server";
import { cooldownActionBar, axeCooldownActionBar, cooldownNormal } from "./lib/cooldownActionBar"
import { setTimeout } from "./lib/timers";

world.events.entityHit.subscribe(async evd => {
    const { entity, hitEntity } = evd;
    if (entity) {
        cooldownNormal(entity)
        setTimeout(() => {
            const effectGet = entity.getEffect(MinecraftEffectTypes.weakness)
            if (!effectGet) {
                entity.removeTag('in_cooldown')
            }
        }, 1000);
    }
    const { x, y, z } = hitEntity.location;
    const inv = entity.getComponent('inventory').container; const dItem = inv.getItem(entity.selectedSlot);
    const swordsID = ["sword", "saber", "katana", "weapon", "blade", "espada"]; const axesID = ["_axe", "tomahawk", "hacha"]; const othersID = ["hoe", "shovel", "pickaxe"];
    const id = dItem.typeId;
    //swords
    for (const swords of swordsID) {
        if (entity.velocity.y < 0 && id.includes(swords)) {
            entity.addEffect(MinecraftEffectTypes.weakness, 20, 0, false)
            if (!entity.hasTag('in_cooldown')) {
                entity.addTag('in_cooldown')
                cooldownActionBar(entity);
                await hitEntity.runCommandAsync(`damage @e[r=2,name=!"${entity.nameTag}"] 3`)
                await entity.runCommandAsync(`playsound 6dad269a-4a3a-41b7-977e-b4c75ca6ca63 @s ${x} ${y} ${z}`)
                world.getDimension('overworld').spawnParticle('new:6dad269a-4a3a-41b7-977e-b4c75ca6ca63', new Location(x, y + 1, z), new MolangVariableMap());
            }
        }
        else if (entity.velocity.y == 0 && id.includes(swords)) {
            entity.addEffect(MinecraftEffectTypes.weakness, 20, 0, false)
            if (!entity.hasTag('in_cooldown')) {
                entity.addTag('in_cooldown')
                cooldownActionBar(entity);
                await hitEntity.runCommandAsync(`damage @e[r=2,name=!"${entity.nameTag}"] 3`)
                await entity.runCommandAsync(`playsound 6dad269a-4a3a-41b7-977e-b4c75ca6ca63 @s ${x} ${y} ${z}`)
                world.getDimension('overworld').spawnParticle('new:6dad269a-4a3a-41b7-977e-b4c75ca6ca63', new Location(x, y + 1, z), new MolangVariableMap());
            }
        }
    }
    //axes
    for (const axes of axesID) {
        if (entity.velocity.y < 0 && id.includes(axes)) {
            entity.addEffect(MinecraftEffectTypes.weakness, 20, 0, false)
            if (!entity.hasTag('in_cooldown')) {
                entity.addTag('in_cooldown')
                axeCooldownActionBar(entity);
                setTimeout(() => {
                    hitEntity.runCommandAsync(`damage @s 5`)
                }, 480);
            }
        }
        else if (entity.velocity.y == 0 && id.includes(axes)) {
            entity.addEffect(MinecraftEffectTypes.weakness, 20, 0, false)
            if (!entity.hasTag('in_cooldown')) {
                entity.addTag('in_cooldown')
                axeCooldownActionBar(entity);
                setTimeout(() => {
                    hitEntity.runCommandAsync(`damage @s 5`)
                }, 480);
            }
        }
    }
    //others
    for (const others of othersID) {
        if (entity.velocity.y < 0 && id.includes(others)) {
            entity.addEffect(MinecraftEffectTypes.weakness, 20, 0, false)
            if (!entity.hasTag('in_cooldown')) {
                entity.addTag('in_cooldown')
                cooldownActionBar(entity);
            }
        }
        else if (entity.velocity.y == 0 && id.includes(others)) {
            entity.addEffect(MinecraftEffectTypes.weakness, 20, 0, false)
            if (!entity.hasTag('in_cooldown')) {
                entity.addTag('in_cooldown')
                cooldownActionBar(entity);
            }
        }
    }
});

system.events.beforeWatchdogTerminate.subscribe((event) => {
    event.cancel = true;
});